/* Copyright (c) 2014, Giovanni Spina <giovanni@codeforfun.it>
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of the uploader nor the
*       names of its contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL GIOVANNI SPINA BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.*/

#include <LCD_Driver.h>
#include <uplifting.h>

sbit CS_PIN at LATB0_bit;
sbit SCK_PIN at LATB1_bit;
sbit DATA_PIN at LATB2_bit;
sbit RESET_PIN at LATB3_bit;

sbit CS_PIN_DIRECTION at TRISB0_bit;
sbit SCK_PIN_DIRECTION at TRISB1_bit;
sbit DATA_PIN_DIRECTION at TRISB2_bit;
sbit RESET_PIN_DIRECTION at TRISB3_bit;

const char* rom_string[] = {
	"Hello World!",
	"by\nGiovanni Spina",
	"Copyright (c)\ncodeforfun.it"
};

void drawtriangle()
{
	uint8 p0x, p0y, p1x, p1y, p2x, p2y;
	uint8 LCD_WIDTH, LCD_HEIGHT;

	LCD_getScreenSize(&LCD_WIDTH, &LCD_HEIGHT);

	p0x = rand() % LCD_WIDTH;
	p0y = rand() % LCD_HEIGHT;

	p1x = rand() % LCD_WIDTH;
	p1y = rand() % LCD_HEIGHT;

	p2x = rand() % LCD_WIDTH;
	p2y = rand() % LCD_HEIGHT;

	LCD_drawFilledTriangle(p0x, p0y, p1x, p1y, p2x, p2y, RGB_ORANGE8);
}

void main() 
{
	ADCON1 |= 0x0F;

	TRISC = 0;
	PORTC = 0;

	LCD_Init(PHILLIPS_CONTROLLER, COLOR8);

	LCD_drawImage(Paesaggio, 0, 0);
	LCD_drawFillRect(10, 10, 40, 20, RGB_BLACK8);
	LCD_drawHorizontalLine(10, 10, 40, RGB_LIGHTBLUE8);
	LCD_drawVerticalLine(10, 10, 20, RGB_LIGHTBLUE8);

	LCD_drawRect(9, 9, 42, 22, RGB_ORANGE8);
	LCD_drawCircle(132/2, 132/2, 40, RGB_BLACK8);
	LCD_drawFillCircle(132/2, 132/2, 20, RGB_LIGHTBLUE8);
	
	LCD_drawRomString(0, 0, rom_string[0], RGB_ORANGE8, RGB_BLACK8, LARGE, JUSTIFY_CENTER);
	LCD_drawRomString(0, 132/2, rom_string[1], RGB_RED8, RGB_BLACK8, MEDIUM, JUSTIFY_LEFT);
	LCD_drawRomString(0, 132-20, rom_string[2], RGB_WHITE8, RGB_BLACK8, SMALL, JUSTIFY_LEFT);
	
	drawtriangle();

	for (;;);
}